(function (_, kotlin_kotlin, kotlin_org_jetbrains_kotlinx_kotlinx_datetime) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var protoOf = kotlin_kotlin.$_$.ba;
  var getStringHashCode = kotlin_kotlin.$_$.d9;
  var hashCode = kotlin_kotlin.$_$.e9;
  var THROW_CCE = kotlin_kotlin.$_$.de;
  var equals = kotlin_kotlin.$_$.y8;
  var classMeta = kotlin_kotlin.$_$.w8;
  var setMetadataFor = kotlin_kotlin.$_$.ca;
  var split = kotlin_kotlin.$_$.oc;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.k;
  var charSequenceLength = kotlin_kotlin.$_$.u8;
  var Unit_instance = kotlin_kotlin.$_$.f4;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.d5;
  var ArrayList_init_$Create$_0 = kotlin_kotlin.$_$.j;
  var Companion_getInstance = kotlin_org_jetbrains_kotlinx_kotlinx_datetime.$_$.a;
  var joinToString = kotlin_kotlin.$_$.j6;
  var startsWith = kotlin_kotlin.$_$.pc;
  var listOf = kotlin_kotlin.$_$.w6;
  var emptyList = kotlin_kotlin.$_$.v5;
  var listOf_0 = kotlin_kotlin.$_$.v6;
  var plus = kotlin_kotlin.$_$.e7;
  var isBlank = kotlin_kotlin.$_$.tb;
  var toInt = kotlin_kotlin.$_$.bd;
  var Companion_instance = kotlin_kotlin.$_$.a4;
  var isCharSequence = kotlin_kotlin.$_$.k9;
  var trim = kotlin_kotlin.$_$.md;
  var toString = kotlin_kotlin.$_$.ga;
  var _Result___init__impl__xyqfz8 = kotlin_kotlin.$_$.b2;
  var createFailure = kotlin_kotlin.$_$.re;
  var _Result___get_value__impl__bjfvqg = kotlin_kotlin.$_$.e2;
  var _Result___get_isFailure__impl__jpiriv = kotlin_kotlin.$_$.c2;
  var getBooleanHashCode = kotlin_kotlin.$_$.a9;
  var first = kotlin_kotlin.$_$.a6;
  var copyToArray = kotlin_kotlin.$_$.r5;
  var to = kotlin_kotlin.$_$.cf;
  var json = kotlin_kotlin.$_$.s9;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CommitRef, 'CommitRef', classMeta);
  setMetadataFor(GitAdapter, 'GitAdapter', classMeta);
  setMetadataFor(GitStatus, 'GitStatus', classMeta);
  //endregion
  function CommitRef(id, authorEmail, committerEmail, dateTime, parents, fullMessage) {
    this.e1h_1 = id;
    this.f1h_1 = authorEmail;
    this.g1h_1 = committerEmail;
    this.h1h_1 = dateTime;
    this.i1h_1 = parents;
    this.j1h_1 = fullMessage;
  }
  protoOf(CommitRef).toString = function () {
    return 'CommitRef(id=' + this.e1h_1 + ', authorEmail=' + this.f1h_1 + ', committerEmail=' + this.g1h_1 + ', dateTime=' + this.h1h_1 + ', parents=' + this.i1h_1 + ', fullMessage=' + this.j1h_1 + ')';
  };
  protoOf(CommitRef).hashCode = function () {
    var result = getStringHashCode(this.e1h_1);
    result = imul(result, 31) + getStringHashCode(this.f1h_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.g1h_1) | 0;
    result = imul(result, 31) + this.h1h_1.hashCode() | 0;
    result = imul(result, 31) + hashCode(this.i1h_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.j1h_1) | 0;
    return result;
  };
  protoOf(CommitRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof CommitRef))
      return false;
    var tmp0_other_with_cast = other instanceof CommitRef ? other : THROW_CCE();
    if (!(this.e1h_1 === tmp0_other_with_cast.e1h_1))
      return false;
    if (!(this.f1h_1 === tmp0_other_with_cast.f1h_1))
      return false;
    if (!(this.g1h_1 === tmp0_other_with_cast.g1h_1))
      return false;
    if (!this.h1h_1.equals(tmp0_other_with_cast.h1h_1))
      return false;
    if (!equals(this.i1h_1, tmp0_other_with_cast.i1h_1))
      return false;
    if (!(this.j1h_1 === tmp0_other_with_cast.j1h_1))
      return false;
    return true;
  };
  function parseLog($this, outputText) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.filter' call
    // Inline function 'kotlin.collections.filterTo' call
    var this_0 = split(outputText, [$this.l1h_1 + '\n']);
    var destination = ArrayList_init_$Create$();
    var tmp0_iterator = this_0.t();
    while (tmp0_iterator.u()) {
      var element = tmp0_iterator.w();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>' call
      // Inline function 'kotlin.text.isNotEmpty' call
      if (charSequenceLength(element) > 0) {
        destination.q(element);
      }
    }
    // Inline function 'kotlin.collections.mapTo' call
    var destination_0 = ArrayList_init_$Create$_0(collectionSizeOrDefault(destination, 10));
    var tmp0_iterator_0 = destination.t();
    while (tmp0_iterator_0.u()) {
      var item = tmp0_iterator_0.w();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>' call
      var elements = split(item, ['\n']);
      var tmp = elements.e1(0);
      var tmp_0 = elements.e1(1);
      var tmp_1 = elements.e1(2);
      var tmp_2 = Companion_getInstance().g1g(elements.e1(3));
      // Inline function 'kotlin.collections.filter' call
      // Inline function 'kotlin.collections.filterTo' call
      var this_1 = split(elements.e1(4), [' ']);
      var destination_1 = ArrayList_init_$Create$();
      var tmp0_iterator_1 = this_1.t();
      while (tmp0_iterator_1.u()) {
        var element_0 = tmp0_iterator_1.w();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>.<anonymous>' call
        // Inline function 'kotlin.text.isNotEmpty' call
        if (charSequenceLength(element_0) > 0) {
          destination_1.q(element_0);
        }
      }
      var tmp$ret$8 = new CommitRef(tmp, tmp_0, tmp_1, tmp_2, destination_1, joinToString(elements.b2(5, elements.n()), '\n'));
      destination_0.q(tmp$ret$8);
    }
    return destination_0;
  }
  function findByPrefix(_this__u8e3s4, $this, prefix) {
    // Inline function 'kotlin.collections.find' call
    var tmp$ret$1;
    $l$block: {
      // Inline function 'kotlin.collections.firstOrNull' call
      var tmp0_iterator = _this__u8e3s4.t();
      while (tmp0_iterator.u()) {
        var element = tmp0_iterator.w();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.findByPrefix.<anonymous>' call
        if (startsWith(element, prefix)) {
          tmp$ret$1 = element;
          break $l$block;
        }
      }
      tmp$ret$1 = null;
    }
    var tmp0_safe_receiver = tmp$ret$1;
    var tmp;
    if (tmp0_safe_receiver == null) {
      tmp = null;
    } else {
      // Inline function 'kotlin.text.substring' call
      var startIndex = prefix.length;
      // Inline function 'kotlin.js.asDynamic' call
      tmp = tmp0_safe_receiver.substring(startIndex);
    }
    return tmp;
  }
  function GitAdapter(workingDirectory) {
    this.k1h_1 = workingDirectory;
    this.l1h_1 = '--------!--------';
    this.m1h_1 = '%H%n%ae%n%ce%n%aI%n%P%n%B%n' + this.l1h_1;
  }
  protoOf(GitAdapter).n1h = function (name, ref) {
    runProcess(listOf(['git', 'tag', '--annotate', '--message=' + name, name, ref]), this.k1h_1);
  };
  protoOf(GitAdapter).o1h = function () {
    runProcess(listOf(['git', 'push', '--tags']), this.k1h_1);
  };
  protoOf(GitAdapter).p1h = function (ref) {
    return findByPrefix(split(runProcess(listOf(['git', 'show', ref, '--format=%D', '--no-patch']), this.k1h_1), [', ']), this, 'tag: ');
  };
  protoOf(GitAdapter).q1h = function (begin, end) {
    return parseLog(this, runProcess(plus(listOf(['git', '--no-pager', 'log', '--format=' + this.m1h_1, begin]), !(end == null) ? listOf_0(end) : emptyList()), this.k1h_1));
  };
  protoOf(GitAdapter).r1h = function () {
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.status.<anonymous>' call
    var output = runProcess(listOf(['git', 'status', '--porcelain=2', '--branch', '--ahead-behind']), this.k1h_1);
    var lines = split(output, ['\n']);
    var head = findByPrefix(lines, this, '# branch.head ');
    var upstream = findByPrefix(lines, this, '# branch.upstream ');
    var tmp0_safe_receiver = findByPrefix(lines, this, '# branch.ab ');
    var tmp1_safe_receiver = tmp0_safe_receiver == null ? null : split(tmp0_safe_receiver, [' ']);
    var tmp;
    if (tmp1_safe_receiver == null) {
      tmp = null;
    } else {
      // Inline function 'kotlin.collections.map' call
      // Inline function 'kotlin.collections.mapTo' call
      var destination = ArrayList_init_$Create$_0(collectionSizeOrDefault(tmp1_safe_receiver, 10));
      var tmp0_iterator = tmp1_safe_receiver.t();
      while (tmp0_iterator.u()) {
        var item = tmp0_iterator.w();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.status.<anonymous>.<anonymous>' call
        // Inline function 'kotlin.text.substring' call
        // Inline function 'kotlin.js.asDynamic' call
        var tmp$ret$2 = item.substring(1);
        destination.q(tmp$ret$2);
      }
      tmp = destination;
    }
    var tmp2_elvis_lhs = tmp;
    var tmp3_container = tmp2_elvis_lhs == null ? listOf(['-1', '-1']) : tmp2_elvis_lhs;
    // Inline function 'kotlin.collections.component1' call
    var a = tmp3_container.e1(0);
    // Inline function 'kotlin.collections.component2' call
    var b = tmp3_container.e1(1);
    // Inline function 'kotlin.collections.filterNot' call
    // Inline function 'kotlin.collections.filterNot' call
    // Inline function 'kotlin.collections.filterNotTo' call
    var destination_0 = ArrayList_init_$Create$();
    var tmp0_iterator_0 = lines.t();
    while (tmp0_iterator_0.u()) {
      var element = tmp0_iterator_0.w();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.status.<anonymous>.<anonymous>' call
      if (!startsWith(element, '#')) {
        destination_0.q(element);
      }
    }
    // Inline function 'kotlin.collections.filterNotTo' call
    var destination_1 = ArrayList_init_$Create$();
    var tmp0_iterator_1 = destination_0.t();
    while (tmp0_iterator_1.u()) {
      var element_0 = tmp0_iterator_1.w();
      if (!isBlank(element_0)) {
        destination_1.q(element_0);
      }
    }
    var tmp_0 = destination_1.a1();
    var tmp_1 = toInt(a);
    var tmp_2 = toInt(b);
    var tmp_3 = head == null ? '' : head;
    return new GitStatus(tmp_0, tmp_1, tmp_2, tmp_3, upstream == null ? '' : upstream);
  };
  protoOf(GitAdapter).s1h = function (abbrev) {
    // Inline function 'kotlin.Result.getOrNull' call
    // Inline function 'kotlin.runCatching' call
    var tmp;
    try {
      // Inline function 'kotlin.Companion.success' call
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.describe.<anonymous>' call
      // Inline function 'kotlin.text.trim' call
      var this_0 = runProcess(listOf(['git', 'describe', '--abbrev=' + abbrev]), this.k1h_1);
      var value = toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
      tmp = _Result___init__impl__xyqfz8(value);
    } catch ($p) {
      var tmp_0;
      if ($p instanceof Error) {
        var e = $p;
        // Inline function 'kotlin.Companion.failure' call
        tmp_0 = _Result___init__impl__xyqfz8(createFailure(e));
      } else {
        throw $p;
      }
      tmp = tmp_0;
    }
    var this_1 = tmp;
    var tmp_1;
    if (_Result___get_isFailure__impl__jpiriv(this_1)) {
      tmp_1 = null;
    } else {
      var tmp_2 = _Result___get_value__impl__bjfvqg(this_1);
      tmp_1 = (tmp_2 == null ? true : !(tmp_2 == null)) ? tmp_2 : THROW_CCE();
    }
    return tmp_1;
  };
  function GitStatus(isClean, ahead, behind, head, upstream) {
    this.t1h_1 = isClean;
    this.u1h_1 = ahead;
    this.v1h_1 = behind;
    this.w1h_1 = head;
    this.x1h_1 = upstream;
  }
  protoOf(GitStatus).toString = function () {
    return 'GitStatus(isClean=' + this.t1h_1 + ', ahead=' + this.u1h_1 + ', behind=' + this.v1h_1 + ', head=' + this.w1h_1 + ', upstream=' + this.x1h_1 + ')';
  };
  protoOf(GitStatus).hashCode = function () {
    var result = getBooleanHashCode(this.t1h_1);
    result = imul(result, 31) + this.u1h_1 | 0;
    result = imul(result, 31) + this.v1h_1 | 0;
    result = imul(result, 31) + getStringHashCode(this.w1h_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.x1h_1) | 0;
    return result;
  };
  protoOf(GitStatus).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof GitStatus))
      return false;
    var tmp0_other_with_cast = other instanceof GitStatus ? other : THROW_CCE();
    if (!(this.t1h_1 === tmp0_other_with_cast.t1h_1))
      return false;
    if (!(this.u1h_1 === tmp0_other_with_cast.u1h_1))
      return false;
    if (!(this.v1h_1 === tmp0_other_with_cast.v1h_1))
      return false;
    if (!(this.w1h_1 === tmp0_other_with_cast.w1h_1))
      return false;
    if (!(this.x1h_1 === tmp0_other_with_cast.x1h_1))
      return false;
    return true;
  };
  function get_childProcess() {
    _init_properties_RunProcess_js_kt__6db8dd();
    return childProcess;
  }
  var childProcess;
  function runProcess(args, workingDirectory) {
    _init_properties_RunProcess_js_kt__6db8dd();
    var program = first(args);
    // Inline function 'kotlin.collections.toTypedArray' call
    var this_0 = args.b2(1, args.n());
    var tmp$ret$0 = copyToArray(this_0);
    var spawn = get_childProcess().spawnSync(program, tmp$ret$0, json([to('cwd', workingDirectory), to('maxBuffer', 10485760)]));
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp0_safe_receiver = spawn.stdout;
    return tmp0_safe_receiver == null ? null : tmp0_safe_receiver.toString('utf8');
  }
  var properties_initialized_RunProcess_js_kt_yehn37;
  function _init_properties_RunProcess_js_kt__6db8dd() {
    if (!properties_initialized_RunProcess_js_kt_yehn37) {
      properties_initialized_RunProcess_js_kt_yehn37 = true;
      childProcess = require('node:child_process');
    }
  }
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = GitAdapter;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./Kotlin-DateTime-library-kotlinx-datetime.js')));

//# sourceMappingURL=tools-git-adapter.js.map
